<!DOCTYPE html>
<html>
<head>
<title>haroldbot</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<link rel="shortcut icon" href="/favicon.ico" />
<link rel="stylesheet" type="text/css" href="mainstyle.css" />
<script type="text/javascript" src="minisat.js"></script>
<script type="text/javascript" src="jquery-1.12.4.min.js"></script>
<script type="text/javascript" src="jquery.color-2.1.2.min.js"></script>
<script type="text/javascript" src="util.js"></script>
<script type="text/javascript" src="expr.js"></script>
<script type="text/javascript" src="parser.js"></script>
<script type="text/javascript" src="bdd.js"></script>
<script type="text/javascript" src="bddfunction.js"></script>
<script type="text/javascript" src="sat.js"></script>
<script type="text/javascript" src="circuit.js"></script>
<script type="text/javascript" src="circuitfunction.js"></script>
<script type="text/javascript" src="prooffinder.js"></script>
<script type="text/javascript">
var $j = jQuery.noConflict();
var id = 0;

var isDarkMode = false;
if (window.matchMedia) {
  isDarkMode = window.matchMedia('(prefers-color-scheme: dark)').matches;
  window.matchMedia('(prefers-color-scheme: dark)').addListener(function (e) {
    isDarkMode = e.matches;
    update();
  });
}

function performQuery(input) {
  id = 0;
  Node.SafeExprCache.clear();
  bdd.reset();
  circuit.reset();
  var p = parse(input);
  var expr = p[0];
  var varmap = p[1];
  var quantified = p[2];
  var msg = p[3];

  if (p[0] == undefined) {
    data = {};
    data.msg = msg;
    update();
    return;
  }

  parens = true;
  var printback = $j("<p>Parsed as:<br/></p>");
  if (quantified)
    printback.append("forall " + quantified.join(", ") + ": ");
  printback.append(formatexpr(expr.removeDummy(), 0, varmap));
  $j('#query-printback').append(printback);
  var nf = expr.removeDummy();
  var cf = nf.constantFold();
  if (!cf.equals2(nf)) {
    var foldprintback = $j("<p>After constant folding:<br/></p>");
    if (quantified)
      foldprintback.append("forall " + quantified.join(", ") + ": ");
    foldprintback.append(formatexpr(cf, 0, varmap));
    $j('#query-printback').append(foldprintback);
  }
  expr = cf;

  data = {
    varmap: varmap.slice(0),
    quantified: quantified || []
  };

  if (!quantified) {
    // try to find some interesting things about an expression
    Node.AnalyzeProperties(data, varmap, expr, update);
  }

  let debugcb = function (exprc, backwards) {
    if (backwards) {
      $j('#exprdebug1').append($j('<div/>').append(formatexpr(exprc, 99999, varmap)));
    }
    else {
      $j('#exprdebug0').append($j('<div/>').append(formatexpr(exprc, 99999, varmap)));
    }
  };

  // try limited search for proof (to avoid having to do anything else for trivially equivalent expressions)
  if (expr.type == 'bin' && (expr.op == 20 || expr.op == 41 || expr.op == 45) && !quantified) {
    var pf = new ProofFinder(expr.op);
    var proof = null;
    pf.Search(expr.l.removeDummy(), expr.r.removeDummy(), function (proofsteps) {
      proof = proofsteps;
    }, null, 'synchronous', 400);
    if (proof != null) {
      data.true = {
        count: '#always',
        proof: proof
      };
      update();
      return;
    }
  }

  var bddf;
  var circuitf;
  try {
    //throw "BDD full";
    bddf = expr.toBddFunc();
    if (quantified)
      bddf = BDDFunction.quantU(bddf, quantified, varmap);
  }
  catch (err) {
    if (err == "BDD full" || err == "multiplication seems hard" || err == "BDD timeout") {
      if (quantified) {
        if (expr.type == 'bin' && binOpResultsInBool(expr.op)) {
          CFunction.AnalyzeTruthQ(data, expr.removeDummy(), varmap, quantified, update);
          return;
        }
        else {
          data.msg = "quantifiers can only be used for boolean expressions";
          update();
          return;
        }
      }
      else
        circuitf = expr.toCircuitFunc();
    }
    else {
      //throw err;
      data.msg = err;
      update();
      return;
    }
  }

  if (!quantified) {
    // re-run this, may find more stuff since (some) bdd functions may be available
    Node.AnalyzeProperties(data, varmap, expr, update);
  }

  if (expr.type == 'bin' && binOpResultsInBool(expr.op)) {
    // comparison
    if (bddf && !quantified) {
      data.simp = bddf.Identify(varmap, true);
      if (data.simp && data.simp.equals(expr))
        data.simp = null;
    }

    (bddf||circuitf).AnalyzeTruth(data, expr.removeDummy(), varmap, update, null);
  }
  else {
    if (quantified) {
      data.msg = "quantifiers can only be used for boolean expressions";
      return;
    }
    if (bddf) {
      bddf.Identify(varmap, false, expr, function (simp){        
        if (simp != null && simp.weight < expr.weight)
          data.simp = simp;
        update();

        if (data.simp == null) {
          data.msg = "no simplication found";
          ProofFinder.proveAsync(expr.removeDummy(), null, 20, function (steps, res) {
            if (!steps) return;
            data.msg = undefined;
            data.simp = res;
            data.proof = steps;
            update();
            Node.AnalyzeProperties(data, varmap, data.simp, update);
          }, null);
        }
        else {
          Node.AnalyzeProperties(data, varmap, data.simp, update);
          ProofFinder.proveAsync(expr.removeDummy(), data.simp, 20, function (steps) {
            if (!steps) return;
            data.proof = steps;
            update();
          });
        }
      });
      
      bddf.AnalyzeProperties(data, varmap, data.simp || expr.removeDummy(), update);
      update();
    }
    else {
      data.msg = "SAT fallback can only handle expressions that result in true or false";

      if (data.simp == null) {
        ProofFinder.proveAsync(expr.removeDummy(), null, 20, function (steps, res) {
          if (!steps) return;
          data.msg = undefined;
          data.simp = res;
          data.proof = steps;
          update();
          Node.AnalyzeProperties(data, varmap, data.simp, update);
        }, function (exprc, backwards) {
          if (backwards) {
            //$j('#exprdebug1').append($j('<div/>').append(formatexpr(exprc, 99999, varmap)));
          }
          else {
            //$j('#exprdebug0').append($j('<div/>').append(formatexpr(exprc, 99999, varmap)));
          }
        });
      }
      update();
    }
  }
}

function formatVariableAssignment(assignment, varmap_in, ext_examples, quantified) {
  var varmap = varmap_in.slice();
  if (ext_examples) {
    varmap.push('lhs');
    varmap.push('rhs');
  }
  var table = $j('<table class="varassignment"></table>');
  for (var i = 0; i < varmap.length; i++) {
    if (i < varmap_in.length && quantified.indexOf(varmap[i]) >= 0) continue;
    var row = $j('<tr></tr>');
    row.append($j('<td>' + varmap[i] + '</td>'));
    row.append("=");
    row.append($j('<td>' + formatConstant(assignment[i]) + '</td>'));
    table.append(row);
  }
  return table;
}

function formatVariableAssignments(assignment, varmap_in, ext_examples, quantified) {
  var varmap = varmap_in.slice();
  if (ext_examples) {
    varmap.push('lhs');
    varmap.push('rhs');
  }
  var wrapper = $j('<div/>');
  var table = $j('<table class="varassignment"></table>');
  var headers = $j('<tr/>');
  if ((varmap.length - quantified.length) > 1 || true) {
    for (var i = 0; i < varmap.length; i++) {
      if (i < varmap_in.length && quantified.indexOf(varmap[i]) >= 0) continue;
      headers.append($j('<th>' + varmap[i] + '</th>'));
    }
    table.append(headers);
  }
  var first = 0;
  var last = 0;
  while (last < 4) {
    var asign = assignment(last++);
    if (asign == undefined)
      break;
    var row = $j('<tr/>');
    for (var i = 0; i < varmap.length; i++) {
      if (i < varmap_in.length && quantified.indexOf(varmap[i]) >= 0) continue;
      var col = $j('<td />').append($j('<span />').attr('title', asign[i]).text(formatConstant(asign[i])));
      row.append(col);
    }
    table.append(row);
  }

  var morebutton = null;
  if (assignment(last) != undefined) {
    morebutton = $j('<button/>');
    morebutton.text('...');
    morebutton.css('border-radius', '5px');
    morebutton.click(function () {
      for (var end = last + 4; last < end; last++) {
        var asign = assignment(last);
        if (asign == undefined)
          break;
        var row = $j('<tr/>');
        for (var i = 0; i < varmap.length; i++) {
          if (i < varmap_in.length && quantified.indexOf(varmap[i]) >= 0) continue;
          row.append($j('<td />').append($j('<span />').attr('title', asign[i]).text(formatConstant(asign[i]))));
        }
        table.append(row);
      }
      table.animate({scrollTop: table.prop('scrollHeight') - table.height()}, 100);
    });
    morebutton.bind('contextmenu', function() {
      if (last == 0)
        return false;
      var end = last - 4;
      while (last > 1 && last > end) {
        last--;
        $j('tr:last', table).remove();
      }
      return false;
    });
  }
  wrapper.append(table);
  if (morebutton != null)
  wrapper.append(morebutton);
  return wrapper;
}

var parens = false;

function formatexpr(expr, ix, varmap) {
  varmap[0];
  var res = $j("<span />").addClass("e" + ix + "_" + expr.id);
  res.css("border-radius", "5px");
  if (expr[0] == "#") {
    res.append(formatexpr(expr[2], ix, varmap));
    return res;
  }
  if (expr.type == 'var') {
    if (expr.index >= 0)
      res.append(varmap[expr.index]);
    else
      res.append(['x', 'y', 'z', 'w', 'p', 'q', 'r', 's', 't', 'u', 'v'][~expr.index]);
    return res;
  }
  if (expr.type == 'const') {
    res.append($j("<span />").attr("title", expr.value).text(formatConstant(expr.value)));
    return res;
  }
  if (expr.type == 'un') {
    var inner = formatexpr(expr.value, ix, varmap);

    if (unops[expr.op].startsWith('$')) {
      return res.append(unops[expr.op].substr(1) + '(').append(inner).append(')');
    }

    res.append(unops[expr.op]);
    if ((expr.value.type == 'bin' && !isbinfunc(expr.value.op)) || expr.value.type == 'ter') {
      res.append('(');
      res.append(inner);
      res.append(')');
    }
    else
      res.append(inner);
    return res;
  }
  if (expr.type == 'bin') {
    var l = formatexpr(expr.l, ix, varmap);
    var r = formatexpr(expr.r, ix, varmap);

    if (ops[expr.op].startsWith('$')) {
      return res.append(ops[expr.op].substr(1) + '(').append(l).append(', ').append(r).append(')');
    }

    if ((expr.l.type == 'bin' || expr.l.type == 'assoc') && (parens && !isbinfunc(expr.l.op) || precedence(expr.op) > precedence(expr.l.op) || (precedence(expr.op) == precedence(expr.l.op) && !associative[expr.l.op])) || expr.l.type == 'ter') {
      res.append('(');
      res.append(l);
      res.append(')');
    }
    else
      res.append(l);
    
    res.append(" " + escapeHtml(ops[expr.op]) + " ");
    
    if ((expr.r.type == 'bin' || expr.r.type == 'assoc') && (parens && !isbinfunc(expr.r.op) || precedence(expr.op) > precedence(expr.r.op) || (precedence(expr.op) == precedence(expr.r.op) && !associative[expr.r.op])) || expr.r.type == 'ter') {
      res.append('(');
      res.append(r);
      res.append(')');
    }
    else
      res.append(r);
      
    return res;
  }
  if (expr.type == 'ter') {
    var cond = formatexpr(expr.cond, ix, varmap);
    var t = formatexpr(expr.t, ix, varmap);
    var f = formatexpr(expr.f, ix, varmap);

    return res.append(cond, " ? ", t, " : ", f);
  }
  if (expr.type == 'assoc') {
    var m = expr.originalOperands.map(function (x) {
      var inner = formatexpr(x, ix, varmap);
      if (!ops[expr.op].startsWith('$') &&
        (x.type == 'ter' || ((x.type == 'bin' || x.type == 'assoc') && (parens && !isbinfunc(x.op) || precedence(expr.op) > precedence(x.op)))))
        return $j("<span />").append("(", inner, ")");
      else
        return inner;
    });

    return m.reduce(function (res, p, i) {
      if (i == 0)
        return res.append(p);
      return res.append(" " + escapeHtml(ops[expr.op]) + " ").append(p);
    }, res);
  }
  if (expr.type == 'fun') {
    var args = expr.args.map(function (a){return formatexpr(a, ix, varmap);});
    res.append(escapeHtml(expr.fun.substr(1))).append("(");
    args.forEach(function (a,i){
      if (i != 0)
        res.append(", ");
      res.append(a);
    });
    res.append(")");
    return res;
  }
  if (expr.type == 'let') {
    res.append("let ");
    for (var i = 0; i < expr.pairs.length; i++) {
      if (i != 0)
        res.append(", ");
      res.append(formatexpr(expr.pairs[i].v, ix, varmap));
      res.append(" = ");
      res.append(formatexpr(expr.pairs[i].expr, ix, varmap));
    }
    res.append(" in ");
    res.append(formatexpr(expr.expr, ix, varmap));
    return res;
  }
  debugger;
}
function parseproofstep(proofstep, ix, varmap, prevstep, nextstep) {
  function getChildExprs(expr) {
    switch (expr.type) {
      default: return [];
      case "bin": return [expr.l, expr.r];
      case "un": return [expr.value];
      case "assoc": return expr.operands;
      case "fun": return expr.args;
      case "ter": return [expr.t, expr.f, expr.cond];
      case "let": return [expr.expr];
    }
  }
  function containsID(expr, id) {
    if (expr.id == id) return true;
    return getChildExprs(expr).some(function(e){return containsID(e, id)});
  }
  var container = $j('<div/>').addClass("proofj");
  container.attr("id", "proofj" + (ix + 1));
  var explanation = $j('<div/>').html(proofstep[0]).contents();
  if (proofstep[2]) {
    var ex = encodeURIComponent(Node.fromBareObject(proofstep[2]).print(varmap));
    explanation.filter('.replace').attr('href', 'index.html?q=' + ex);
  }
  var explanationTextSpan = $j("<span />").append(explanation);
  container.append(explanationTextSpan);
  if (proofstep[1]) {
    var oldparens = parens;
    if (proofstep[0].indexOf("associativity") == 0)
      parens = true;
    container.append(", ");
    var pattern, patternr;
    if (proofstep[1].op == 20 || proofstep[1].op == 41 || proofstep[1].op == 45) {
      pattern = formatexpr(["#",-1,proofstep[1].l], ix, varmap);
      patternr = formatexpr(["#",-1,proofstep[1].r], ix + 2, varmap);
    }
    else {
      pattern = formatexpr(["#",-1,proofstep[1]], ix, varmap);
    }
    parens = oldparens;
    if ((proofstep[1].l.type == 'bin' || proofstep[1].l.type == 'assoc') && precedence(proofstep[1].l.op) <= precedence(proofstep[1].op))
      pattern = $j("<span />").append("(").append(pattern).append(")");
    if (patternr && (proofstep[1].r.type == 'bin' || proofstep[1].r.type == 'assoc') && precedence(proofstep[1].r.op) <= precedence(proofstep[1].op))
      patternr = $j("<span />").append("(").append(patternr).append(")");
    var patternholder = $j('<span />');
    patternholder.css('font-family', 'Consolas,monospace');
    patternholder.append(pattern);
    if (patternr) {
      let patternOp = $j("<span />").append(ops[proofstep[1].op]);
      if (proofstep[1].op != 20) {
        patternOp.css('font-weight', 'bold');
        patternOp.css('text-decoration', 'underline');
        //container.css('color', '#FFFF8C');
        container.addClass('relstep');
      }
      patternholder.append(" ").append(patternOp).append(" ").append(patternr);
    }
    container.append(patternholder);
    // hover anim for the whole step
    {
      var cl1, cl2;
      if (patternr) {
        if (prevstep || nextstep) {
          var highlight_L = [proofstep[1].l];
          var highlight_R = [proofstep[1].r];
          function matchhighlights(hl, expr) {
            hl = hl.slice();
            var i;
            while ((i = hl.findIndex(function(h){return!containsID(expr,h.id)}))>=0) {
              var item = hl[i];
              hl.splice(i, 1);
              hl = hl.concat(getChildExprs(item));
            }
            return hl;
          }
          if (prevstep) highlight_L = matchhighlights(highlight_L, prevstep);
          if (nextstep) highlight_R = matchhighlights(highlight_R, nextstep);
          cl1 = highlight_L.map(function(h){return".e"+ix+"_"+h.id;}).join(", ");
          cl2 = highlight_R.map(function(h){return".e"+(ix+2)+"_"+h.id;}).join(", ");
        }
        else {
          cl1 = ".e" + ix + "_" + proofstep[1].l.id;
          cl2 = ".e" + (ix + 2) + "_" + proofstep[1].r.id;
        }
      }
      else {
        cl1 = (".e" + ix + "_" + proofstep[1].l.id) + ", " +
              (".e" + ix + "_" + proofstep[1].r.id);
        cl2 = null;
      }
      var stepColorF = randomColor(isDarkMode);
      var stepColorT = randomColor(isDarkMode);
      explanationTextSpan.hover(function() {
        $j("#proofj" + ix + ", #proofj" + (ix + 1)).find(cl1).stop().animate({backgroundColor: stepColorF}, 300);
        if (cl2)
          $j("#proofj" + (ix + 1) + ", #proofj" + (ix + 2)).find(cl2).stop().animate({backgroundColor: stepColorT}, 300);
      }, function() {
        $j(cl1).find('span').andSelf().stop().css("background-color", "");
        if (cl2)
          $j(cl2).find('span').andSelf().stop().css("background-color", "");
      });
    }
    // hover anims for sub-expressions
    pattern.find('span').each(function(index, elem) {
      var cl = "." + $j(elem).attr('class');
      var color = randomColor(isDarkMode);
      $j(elem).hover(function() {
        $j("#proofj" + ix + ", #proofj" + (ix + 1)).find(cl).stop().animate({backgroundColor: color}, 300);
      }, function() {
        $j(cl).find('span').andSelf().stop().css("background-color", "");
      });
    });
    if (patternr) {
      patternr.find('span').each(function(index, elem) {
        var cl = "." + $j(elem).attr('class');
        var color = randomColor(isDarkMode);
        $j(elem).hover(function() {
          $j("#proofj" + (ix + 1) + ", #proofj" + (ix + 2)).find(cl).stop().animate({backgroundColor: color}, 300);
        }, function () {
          $j(cl).find('span').andSelf().stop().css("background-color", "");
        });
      });
    }
  }
  return container;
}
function formatproof(parent, proofarray, varmap) {
  varmap[0];
  var assocsteps = true; //$j('#explicitparens').is(':checked');
  var proofcontainer = $j('<p/>');
  proofcontainer.append($j('<p>proof:</p>'));
  var havesteps = false;
  for (var i = 0; i < proofarray.length; i++) {
    if (i % 2 == 0) {
      var container = $j('<div/>');
      container.attr("id", "proofj" + i);
      var exprholder = $j('<b/>');
      exprholder.css('font-family', 'Consolas,monospace');
      container.append(exprholder.append(formatexpr(proofarray[i], i, varmap)));
      proofcontainer.append(container);
    }
    else {
      if (proofarray[i].length == 0) {
        var cheatstep = $j('<span/>').append("the proof engine cheated - please file a bug report");
        cheatstep.css('color', '#F77');
        proofcontainer.append($j('<div/>').append(cheatstep));
      }
      if (!assocsteps && proofarray[i][0] && proofarray[i][0].indexOf('associativity') == 0)
        i++;
      else {
        proofcontainer.append(parseproofstep(proofarray[i], i - 1, varmap, proofarray[i - 1], proofarray[i + 1]));
        havesteps = true;
      }
    }
  }
  $j('#displayoptions').show();
  if (havesteps)
    parent.append(proofcontainer);
}

var data = null;

function update(optdata) {
  if (optdata)
    data = optdata;

  parens = $j('#explicitparens').is(':checked');
  $j('#resultDiv').empty();
  
  if (data == null || data == undefined) {
    $j('#resultDiv').append("Query Failed");
    return;
  }
  var varmap = data.varmap;

  if (data.msg) {
    $j('#resultDiv').append('<p>' + data.msg + '</p>');
  }

  function makeMainInfoBox(stuff, name) {
    if (!stuff)
      return;

    var container = $j('<fieldset/>');
    container.append($j('<legend>' + name + '</legend>'));
    if (stuff.count.toString().startsWith('#')) {
      container.append('<p>' + stuff.count.substring(1) + '</p>');
      if (stuff.examples)
        container.append($j('<p>for example:</p>').append(formatVariableAssignments(stuff.examples, varmap, stuff.ext_examples, data.quantified)));
      if (stuff.proof)
        formatproof(container, stuff.proof, varmap);
    }
    else if (stuff.count == 1n) {
      if (stuff.examples) {
        var varassign = formatVariableAssignment(stuff.examples(0), varmap, stuff.ext_examples, data.quantified);
        container.append($j('<p>once, namely:</p>').append(varassign));
      }
      else
        container.append('<p>once</p>');
    }
    else if (stuff.count) {
      let countElement = $j('<p>in </p>').append(
        $j('<span />').attr('title', formatBigInt(stuff.count)).append(stuff.count.toString()));
      let specialValue = detectSpecialBigIntValue(stuff.count);
      if (specialValue) {
        if (specialValue.kind == "power-minus-k") {
          if (specialValue.k == 0)
            countElement.append(' (aka ' + specialValue.base, $j('<sup />').append(specialValue.exponent), ')');
          else {
            countElement.append(' (aka ', specialValue.base,
              $j('<sup />').append(specialValue.exponent),
              ' - ', specialValue.k, ' )');
          }
        }
        else if (specialValue.kind == "fibonacci") {
          let span = $j('<span />').css('font-size', '120%');
          span.append($j('<span />').attr('title', 'Fibonacci').append('<i>F</i>'), 
            $j('<sub />').append(specialValue.n));
          countElement.append(' (aka ', span, ' )');
        }
        else if (specialValue.kind == "choose") {
          let span = $j('<span />').css('font-size', '140%');
          span.append('(', 
            $j('<span />').css('display', 'inline-block').append(
              $j('<sup />').addClass('relblock').css('top', '0.25em').append(specialValue.n),
              $j('<sub />').addClass('relblock').css('top', '0.45em').append(specialValue.k)),
            ')');
          countElement.append(' (aka ', span, ' )');
        }
        else if (specialValue.kind == "sum-of-choose") {
          let span = $j('<span />').addClass('nobr').css('font-size', '140%');
          let sum = $j('<span />').css({'display': 'inline-block', 'position': 'relative', 'margin-top': '0.5em'}).append(
            $j('<sup />').addClass('absblock').css({'top': '-1em', 'left': '-1.2em', 'width': '4em'}).append(specialValue.k),
            $j('<span />').css('font-size', '120%').append('&sum;'),
            $j('<sub />').addClass('absblock').css({'top': '2.2em', 'left': '-1.2em', 'width': '4em'}).append('i = 0'));
          span.append(sum, '(', 
            $j('<span />').css('display', 'inline-block').append(
              $j('<sup />').addClass('relblock').css('top', '0.25em').append(specialValue.n),
              $j('<sub />').addClass('relblock').css('top', '0.45em').append('i')),
            ')');
          countElement.append(' (aka ', span, ' )');
        }
      }
      countElement.append(' cases');
      container.append(countElement);
      if (stuff.pred)
        container.append($j('<p>namely when: </p>').append(formatexpr(stuff.pred, 1000000, varmap)));
      if (stuff.examples)
        container.append($j('<p>for example:</p>').append(formatVariableAssignments(stuff.examples, varmap, stuff.ext_examples, data.quantified)));
    }
    else {
      debugger;
      alert('should be unreachable');
    }
    
    $j('#resultDiv').append(container);
  }

  makeMainInfoBox(data.diverror, 'divide error');
  makeMainInfoBox(data.true, 'true');
  makeMainInfoBox(data.false, 'false');

  if (data.simp) {
    $j('#displayoptions').show();
    var simpcont = $j('<fieldset/>');
    simpcont.append($j('<legend>simplified</legend>'));
    simpcont.append($j('<b></b>').append(formatexpr(data.simp, 1000000, data.varmap)));
    if (data.proof) {
      if (data.proof[1][0] != 'structurally equal')
        formatproof(simpcont, data.proof, data.varmap);
    }
    
    $j('#resultDiv').append(simpcont);
  }
  if (data.properties) {
    let prop = data.properties;
    let propscont = $j('<fieldset/>');
    propscont.append($j('<legend>properties</legend>'));
    let haveAny = false;
    if (prop.hasOwnProperty('nibmask')) {
      propscont.append($j('<div>nibble mask: ' + prop.nibmask + '</div>'));
      haveAny = true;
    }
    if (prop.hasOwnProperty('bitmask')) {
      propscont.append($j('<div>bit mask: ' + prop.bitmask + '</div>'));
      haveAny = true;
    }

    function makeCollapsible(base, text, value, count, examples, varmap) {
      var extra = null;
      if (count == "1")
        extra = $j('<div/>').append('once:').append(formatVariableAssignment(examples(0), varmap, false, data.quantified));
      else
        extra = $j('<div/>').append(count + ' cases').append(formatVariableAssignments(examples, varmap, false, data.quantified));
      extra.css('overflow', 'hidden');
      var showbutton = $j('<a/>', {
        text: '▸',
        style: isDarkMode ? 'color:#eee' : 'color:#000',
        class: 'bigger',
        click: function() { extra.slideToggle(); $j(this).text($j(this).text() == '▸' ? '▾' : '▸'); }
      });
      base.append($j('<div/>').append(text + formatConstant(value) + '&nbsp;').append(showbutton));
      base.append(extra);
      extra.hide();
    }

    if (prop.hasOwnProperty('lowestUnsigned')) {
      makeCollapsible(propscont, 'lowest unsigned: ', prop.lowestUnsigned.value, prop.lowestUnsigned.count, prop.lowestUnsigned.examples, data.varmap);
      haveAny = true;
    }
    if (prop.hasOwnProperty('highestUnsigned')) {
      makeCollapsible(propscont, 'highest unsigned: ', prop.highestUnsigned.value, prop.highestUnsigned.count, prop.highestUnsigned.examples, data.varmap);
      haveAny = true;
    }

    if (prop.hasOwnProperty('commutative')) {
      let propcomm = $j('<div>commutative: </div>');
      propcomm.append(prop.commutative + " ");
      propcomm.append($j('<a>proof</a>').attr('href', 'index.html?q=' + encodeURIComponent(prop.commutativeproof)));
      propscont.append(propcomm);
      haveAny = true;
    }

    function drawMatrixOnCanvas(canvas, M, varmap) {
      const scale = 3;
      canvas.width = M.length * scale;
      let ctx = canvas.getContext("2d");
      ctx.fillStyle = "lightgray";
      ctx.fillRect(0, 0, M.length * scale, 16);
      ctx.fillStyle = "white";
      ctx.fillRect(0, 16, M.length * scale, scale * 32);
      ctx.fillStyle = "black";
      ctx.font = "16px sans-serif";
      for (let i = 0; i < varmap.length; i++) {
        ctx.fillText(varmap[i], i * 32 * scale + 0.1, 12.5);
      }
      for (let i = 0; i < M.length; i++) {
        for (let j = 0; j < 32; j++) {
          if ((M[i] & (1 << j)) != 0) {
            // use this instead of fillRect for weird firefox reasons?
            ctx.beginPath();
            ctx.rect(i * scale, j * scale + 16, scale, scale);
            ctx.fill();
            ctx.closePath();
          }
        }
      }
    }

    if (prop.hasOwnProperty('bitwiselinear')) {
      let propcomm = $j('<div>bitwise linear:<br/></div>');
      let cvM = $j('<canvas id="cvM" height="112"></canvas>');
      drawMatrixOnCanvas(cvM.get(0), prop.bitwiselinear.M, data.varmap);
      propcomm.append(cvM);
      propscont.append(propcomm);
      haveAny = true;
    }

    if (prop.hasOwnProperty('inverse')) {
      let propinv = $j('<div>inverse: </div>');
      propinv.append(formatexpr(prop.inverse, -1, data.varmap));
      propinv.append(" ");
      propinv.append($j('<a>proof</a>').attr('href', 'index.html?q=' + encodeURIComponent(prop.inverseproof)));
      propscont.append(propinv);
      $j('#displayoptions').show();
      haveAny = true;
    }
    else if (prop.hasOwnProperty('invertible')) {
      let propinv = $j('<div>invertible: </div>');
      propinv.append(prop.invertible + " ");
      propinv.append($j('<a>proof</a>').attr('href', 'index.html?q=' + encodeURIComponent(prop.inverseproof)));
      propscont.append(propinv);
      haveAny = true;
    }

    if (prop.hasOwnProperty('bitwiselinearinverse')) {
      let propcomm = $j('<div>bitwise linear inverse:<br/></div>');
      let cvM = $j('<canvas id="cvinvM" height="112"></canvas>');
      drawMatrixOnCanvas(cvM.get(0), prop.bitwiselinearinverse.M, ["r"]);
      propcomm.append(cvM);
      propscont.append(propcomm);
      haveAny = true;
    }

    // only make this box if there's anything in it
    if (haveAny)
      $j('#resultDiv').append(propscont);
  }

  if ($j('#resultDiv').is(':empty')) {
    $j('#resultDiv').append('<p>Query yielded nothing interesting</p>');
  }
}

function doquery(f) {
  if (f === undefined || f == null || f.length == 0)
    return;
  $j('#displayoptions').hide();
  $j('#q').val(decodeURIComponent(f.replace(/\+/g, " ")));
  $j('#resultDiv').empty();
  $j('#resultDiv').text('Waiting for result...');
  performQuery(decodeURIComponent(f.replace(/\+/g, " ")));
}
$j(document).ready(function(){
  if (ls.get('explicitparens'))
    $j('#explicitparens').prop('checked', ls.get('explicitparens') == 2);
  $j(':checkbox').change(function() {
    ls.set('explicitparens', $j('#explicitparens').is(':checked') ? 2 : 1);
    update();
  });
  doquery(urlParam('q'));
});
</script>
</head>
<body>
<div id="header"><h1>haroldbot 2</h1>
<br/><br/>
</div>
<div id="querybar">
  <div id="querybox">
    <form method="get">
      <input type="text" placeholder="query" name="q" id="q" autofocus/>
      <input type="submit" value="ask" id="submit"/>
    </form>
  </div>
</div>
<div id="page">
  <div id="displayoptions" style="display:none">
    <label><input type="checkbox" id="explicitparens" />show more parentheses</label>
  </div>
  <div id="query-printback"></div>
  <div id="resultDiv"></div>
  <div id="examples">
    <h2>Examples</h2>
    <p>Just do some math<br/>
      &nbsp;&nbsp;&nbsp;&nbsp;<a href="index.html?q=1000+%2B+15+%26+-16"><tt>1000 + 15 &amp; -16</tt></a></p>
    <p>Find out whether two expressions are equivalent<br/>
      &nbsp;&nbsp;&nbsp;&nbsp;<a href="index.html?q=let+x+%3D+a+%2B+b+in+%28x+<+a%29+%3D%3D+%28x+<+max%28a%2C+b%29%29"><tt>let x = a + b in (x &lt; a) == (x &lt; max(a, b))</tt></a></p></p>
    <p><i>Prove</i> that two expressions are equivalent<br/>
      &nbsp;&nbsp;&nbsp;&nbsp;<a href="index.html?q=a+%5E+%28%28a+%5E+b%29+%26+mask%29+%3D%3D+%28a+%26+~mask%29+%7C+%28b+%26+mask%29"><tt>a ^ ((a ^ b) &amp; mask) == (a &amp; ~mask) | (b &amp; mask)</tt></a></p></p>
    <p>Find when two expressions are equal and when they are not<br/>
      &nbsp;&nbsp;&nbsp;&nbsp;<a href="index.html?q=x+%3D%3D+-x"><tt>x == -x</tt></a></p>
    <p>Quantify some variables away to find values that always work<br/>
      &nbsp;&nbsp;&nbsp;&nbsp;<a href="index.html?q=forall+x%3A+-x+%3D%3D+%28x+%5E+m%29+-+m"><tt>forall x: -x == (x ^ m) - m</tt></a></p>
  </div>
  <div>
    <h2>Notes</h2>
    <p>Tip: a saved copy of this page works offline.</p>
    <p>See the table of operators below for operator precedence.</p>
    <p>Comparisons result in 0 (false) or -1 (true).</p>
    <p>Finding proofs can be slow and often nothing is found at all.</p>
    <p>SAT fallback now exists, using MiniSat compiled with Emscripten. This is brand new so expect bugs (not due to MiniSat, but for example I don't entirely trust my circuit builder and circuit-to-SAT converter). haroldbot should now give up early on (some) multiplications that would create a gigantic BDD.</p>
    <p>In general, there <i>are</i> many bugs.</p>
    <p>Since everything happens client-side, I don't get automatic bug reports. Please <a href="https://gitlab.com/haroldaptroot/haroldbot/-/issues">open an issue</a> or contact me (eg via email, <a rel="me" href="https://mastodon.gamedev.place/@harold">Mastodon</a> @harold@mastodon.gamedev.place or twitter @HaroldAptroot).</p>
    <p>Overview of <a href="how.html">how haroldbot works</a>.</p>
  </div>
  <div>
    <h2>List of available functions</h2>
    <ul>
      <li><tt>min = min_u, min_s</tt></li>
      <li><tt>max = max_u, max_s</tt></li>
      <li><tt>ror, rol</tt> bitwise rotate</li>
      <li><tt>addus, addss, subus, subss</tt> (un)signed saturating addition and subtraction</li>
      <li><tt>avg, avg_up</tt> unsigned average, rounded down or up respectively</li>
      <li><tt>ternlog</tt></li>
      <li><tt>popcnt</tt></li>
      <li><tt>abs</tt></li>
      <li><tt>nlz</tt> (alias <tt>lzcnt</tt>) number of leading zeroes</li>
      <li><tt>ntz</tt> (alias <tt>tzcnt</tt>) number of trailing zeroes</li>
      <li><tt>reverse</tt> bit-reversal</li>
      <li><tt>grev</tt> generalized bit-reversal (2 arguments)</li>
      <li><tt>hmul = hmul_u, hmul_s</tt> high half of product</li>
      <li><tt>blsi, blsr, blsmsk, tzmsk</tt> BMI operations</li>
      <li><tt>bzhi, pdep, pext</tt> BMI2 operations</li>
      <li><tt>clmul</tt> carryless multiplication</li>
      <li><tt>grevmul</tt> it's grevmul, whatever that is</li>
    </ul>
  </div>
  <div>
    <h2>Operators</h2>
<style type="text/css">
.tg  {border-collapse:collapse;border-spacing:0;}
.tg td{border-color:black;border-style:solid;border-width:1px;font-family:Arial, sans-serif;font-size:14px;
  overflow:hidden;padding:10px 5px;word-break:normal;}
.tg th{border-color:black;border-style:solid;border-width:1px;font-family:Arial, sans-serif;font-size:14px;
  font-weight:normal;overflow:hidden;padding:10px 5px;word-break:normal;}
.tg .tg-u4s2{border-color:#000000;font-family:"Courier New", Courier, monospace !important;text-align:left;vertical-align:top}
.tg .tg-wp8o{border-color:#000000;text-align:center;vertical-align:top}
.tg .tg-73oq{border-color:#000000;text-align:left;vertical-align:top}
</style>
<table class="tg"><thead>
  <tr>
    <th class="tg-wp8o">Precedence</th>
    <th class="tg-73oq">Operator</th>
    <th class="tg-73oq">Description</th>
  </tr></thead>
<tbody>
  <tr>
    <td class="tg-wp8o">1</td>
    <td class="tg-u4s2">let ... in ...</td>
    <td class="tg-73oq">"let" expression</td>
  </tr>
  <tr>
    <td class="tg-wp8o" rowspan="2">2</td>
    <td class="tg-u4s2">~<br></td>
    <td class="tg-73oq">bitwise complement</td>
  </tr>
  <tr>
    <td class="tg-u4s2">-</td>
    <td class="tg-73oq">negation</td>
  </tr>
  <tr>
    <td class="tg-wp8o" rowspan="8">3</td>
    <td class="tg-u4s2">*</td>
    <td class="tg-73oq">multiplication</td>
  </tr>
  <tr>
    <td class="tg-u4s2">/ /u</td>
    <td class="tg-73oq">unsigned division</td>
  </tr>
  <tr>
    <td class="tg-u4s2">/s</td>
    <td class="tg-73oq">signed division</td>
  </tr>
  <tr>
    <td class="tg-u4s2">/e</td>
    <td class="tg-73oq">Euclidean division</td>
  </tr>
  <tr>
    <td class="tg-u4s2">/p</td>
    <td class="tg-73oq">unsigned division but division by zero yields zero</td>
  </tr>
  <tr>
    <td class="tg-u4s2">% %u</td>
    <td class="tg-73oq">unsigned remainder</td>
  </tr>
  <tr>
    <td class="tg-u4s2">%s</td>
    <td class="tg-73oq">signed remainder</td>
  </tr>
  <tr>
    <td class="tg-u4s2">%e</td>
    <td class="tg-73oq">Euclidean remainder</td>
  </tr>
  <tr>
    <td class="tg-wp8o" rowspan="2">4</td>
    <td class="tg-u4s2">+</td>
    <td class="tg-73oq">addition</td>
  </tr>
  <tr>
    <td class="tg-u4s2">-</td>
    <td class="tg-73oq">subtraction</td>
  </tr>
  <tr>
    <td class="tg-wp8o" rowspan="3">5</td>
    <td class="tg-u4s2">&lt;&lt;</td>
    <td class="tg-73oq">shift left</td>
  </tr>
  <tr>
    <td class="tg-u4s2">&gt;&gt; &gt;&gt;u</td>
    <td class="tg-73oq">shift right (logical)</td>
  </tr>
  <tr>
    <td class="tg-u4s2">&gt;&gt;s</td>
    <td class="tg-73oq">shift right (arithmetic)</td>
  </tr>
  <tr>
    <td class="tg-wp8o">6</td>
    <td class="tg-u4s2">&amp;</td>
    <td class="tg-73oq">bitwise AND</td>
  </tr>
  <tr>
    <td class="tg-wp8o">7</td>
    <td class="tg-u4s2">^</td>
    <td class="tg-73oq">bitwise XOR</td>
  </tr>
  <tr>
    <td class="tg-wp8o">8</td>
    <td class="tg-u4s2">|</td>
    <td class="tg-73oq">bitwise OR</td>
  </tr>
  <tr>
    <td class="tg-wp8o" rowspan="10">9</td>
    <td class="tg-u4s2">==</td>
    <td class="tg-73oq">compare equal</td>
  </tr>
  <tr>
    <td class="tg-u4s2">!=</td>
    <td class="tg-73oq">compare not equal</td>
  </tr>
  <tr>
    <td class="tg-u4s2">&lt; &lt;u</td>
    <td class="tg-73oq">compare unsigned less than</td>
  </tr>
  <tr>
    <td class="tg-u4s2">&lt;s</td>
    <td class="tg-73oq">compare signed less than</td>
  </tr>
  <tr>
    <td class="tg-u4s2">&gt; &gt;u</td>
    <td class="tg-73oq">compare unsigned greater than</td>
  </tr>
  <tr>
    <td class="tg-u4s2">&gt;s</td>
    <td class="tg-73oq">compare signed greater than</td>
  </tr>
  <tr>
    <td class="tg-u4s2">&lt;= &lt;=u</td>
    <td class="tg-73oq">compare unsigned less than or equal</td>
  </tr>
  <tr>
    <td class="tg-u4s2">&lt;=s</td>
    <td class="tg-73oq">compare signed less than or equal</td>
  </tr>
  <tr>
    <td class="tg-u4s2">&gt;= &gt;=u</td>
    <td class="tg-73oq">compare unsigned greater than or equal</td>
  </tr>
  <tr>
    <td class="tg-u4s2">&gt;=s</td>
    <td class="tg-73oq">compare signed greater than or equal</td>
  </tr>
  <tr>
    <td class="tg-wp8o">10</td>
    <td class="tg-u4s2">&amp;&amp;</td>
    <td class="tg-73oq">Boolean AND, implicitly converts integer operands to Boolean</td>
  </tr>
  <tr>
    <td class="tg-wp8o">11</td>
    <td class="tg-u4s2">||</td>
    <td class="tg-73oq">Boolean OR, implicitly converts integer operands to Boolean</td>
  </tr>
  <tr>
    <td class="tg-wp8o">12</td>
    <td class="tg-u4s2">=&gt;</td>
    <td class="tg-73oq">Boolean implication, implicitly converts integer operands to Boolean</td>
  </tr>
  <tr>
    <td class="tg-wp8o">13</td>
    <td class="tg-u4s2">... ? ... : ...</td>
    <td class="tg-73oq">Ternary operator if the condition is a Boolean, otherwise bitwise MUX</td>
  </tr>
</tbody></table>
  </div>
  <div id="exprdebug">
    <div id="exprdebug0"></div>
    <div id="exprdebug1"></div>
  </div>
</div>
</body>
</html>
